/* SIMPLE LIQUID DISPENSER BY A. SAMIUDDHIN */


const int Button = 0;
const int RLED = 4;                       
const int GLED =3;
const int Valve = 1;
const int PulsesPerLitre = 450;       // Number of Pulse output per litre flow
boolean buttonstate = HIGH;
boolean previousstate = true;
boolean state = LOW;
volatile unsigned int count = 0;     // Interrupt count

void setup()
{
  pinMode(RLED, OUTPUT);
  pinMode(GLED, OUTPUT);
  pinMode(Valve, OUTPUT);
  pinMode(Button, INPUT_PULLUP);      // Input with internal Pullup
  pinMode(2, INPUT_PULLUP);           // Input with internal Pullup
  attachInterrupt(0, flow, FALLING);  // Initialise Interrupt
}

void loop()
{
  buttonstate = digitalRead(Button);   // Read Button State
  if((buttonstate==LOW)&&(previousstate==true)) // Start filling
  {
    dispense();
    previousstate = false;
  }
  else
  {
    digitalWrite(RLED, HIGH);         // Standby or Filling completed
    digitalWrite(GLED, LOW);
    previousstate = true;
  }
}

void dispense()                       // Counting Litres
{
  while(count<PulsesPerLitre)
  {
    digitalWrite(Valve, HIGH);
    digitalWrite(RLED, LOW);
    digitalWrite(GLED, state);
    delay(256);
    state=!state;
  }
  count=0;
  digitalWrite(Valve, LOW);
}

void flow()                           // ISR
{
  count++;
}
